//SpracheGruppenKopie_306d.js
// 08.11.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Kopiert die gewhlte Absatz- und Zeichenformatgruppe, ndert die Sprache der Formate und weist diese dem Text der Ziel-Ebene zu.

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// eine Referenz zum vordersten Dokument
var curDoc = app.documents[0];

// die Ebenennamen auflisten
var allLayers = curDoc.layers.everyItem().name;

// die aktive Ebene feststellen
var curLayer = app.activeWindow.activeLayer.index;

// prfen, ob Absatzformat-Gruppen bestehen
paraGroups = curDoc.paragraphStyleGroups;
var nPSG = paraGroups.length;

// prfen, ob Zeichenformat-Gruppen bestehen
charGroups = curDoc.characterStyleGroups;
var nCSG = charGroups.length;

//--- die Liste der Absatzformatgruppen-Namen aufstellen ---//
var noParaStyles = false;
if (nPSG == 0) {
	var pRoot = true;
	// die Absatzformate auflisten
	var allParaStyles = curDoc.paragraphStyles;
	var nAllPara = allParaStyles.length;
	if (nAllPara >2) {
		// ein leeres Element und Vorgabename der Gruppe
		paraGroups =  new Array ("[Root]");
		pGroupNames = new Array ("", "[Root]");
		nPSG = 2;
	}
	else {
		// keine Absatzformate vorhanden
		noParaStyles = true;
	}
}
else {
	var pRoot = false;
	pGroupNames = paraGroups.everyItem().name;
	// zu Beginn ein leeres Element einfgen
	pGroupNames = [""].concat(pGroupNames);
	nPSG++;
}

//--- die Liste der Zeichenformatgruppen-Namen aufstellen ---//
var noCharStyles = false;
if (nCSG == 0) {
	var cRoot = true;
	var allCharStyles = curDoc.characterStyles;
	var nAllChar = allCharStyles.length;
	if (nAllChar >1) {
		// ein leeres Element und Vorgabename der Gruppe
		charGroups =  new Array ("[Root]");
		cGroupNames = new Array ("", "[Root]");
		nCSG = 2;
	}
	else {
		// keine Zeichenformate vorhanden
		noCharStyles = true;
	}
}
else {
	var cRoot = false;
	cGroupNames = charGroups.everyItem().name;
	// zu Beginn ein leeres Element einfgen
	cGroupNames = [""].concat(cGroupNames);
	nCSG++;
}
// wenn keine Gruppen: prfen, ob berhaupt Formate vorhanden sind
if (noParaStyles && noCharStyles) {
	alert ("Es sind keine benutzerdefinierte Formate vorhanden.", "Stop");
	exit();
}

// die Liste(n) der verfgbaren Sprachen
var allLang = app.languagesWithVendors;
var lngNameList = app.languagesWithVendors.everyItem().name;
var locLangList = app.languagesWithVendors.everyItem().name;
locLangList.sort();
var noLang = locLangList.pop();
locLangList.unshift(noLang);

// die Datei lesen, in welcher die letzte Auswahl gespeichert ist
var langDef = "";
if ($.os.slice(0,7) == "Windows") {
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/LangCopyGroup_306.txt");
}
else {
	var f = new File("~/Library/Preferences/LangCopyGroup_306.txt");
}
var fileIsOpen = f.open("r");
if (fileIsOpen) {
	try {
		langDef = (f.read());
		f.close();
	}
	catch (e) {
		try {
			f.close();
		}
		catch (e) {
		}
	}
}
// die gespeicherten Werte ausziehen
if (langDef != "") {
	var defVal = langDef.split("\n");
	oldPara = defVal[0];
	newParaGroupName = defVal[1];
	pCop = defVal[2];
	if (pCop == "false") { pCop = false; pMov = true; }
	else {pCop = true; pMov = false;}
	oldChar = defVal[3];
	newCharGroupName = defVal[4];
	cCop = defVal[5];
	if (cCop == "false") { cCop = false; cMov = true; }
	else {cCop = true; cMov = false;}
	curLang = (defVal[6])*1;
	nFrc = defVal[7];
	if (nFrc == "true") { nFrc = true; dFrc = false; }
	else { dFrc = true; nFrc = false; }
	curLayer = defVal[8]*1;
	newLayerName = defVal[9];
	newLayerColorID = defVal[10]*1;
}
else {
	var newParaGroupName = newCharGroupName = "";
	var pCop = cCop = dFrc = true;
	var pMov = cMov = nFrc = false;
	var curLang = 1;
	var cSel = pSel = 0;
	var oldChar = oldPara = "";
	var curLayer = 0;
	var newLayerName = "";
	var newLayerColorID = 1;
}

// den Index der alten Gruppen-Namen feststellen
if (nPSG == 2) {
	pSel = 1;
}
else if (nPSG != 0) {
	for (var p=1; p<nPSG; p++) {
		curGrp = pGroupNames[p];
		if (oldPara == curGrp) {
			pSel = p;
			break;
		}
	}
}
if (nCSG == 0) {
	cSel = 0;
}
if (nCSG == 1) {
	cSel = 0;
}
else if (nCSG == 2) {
	cSel = 1;
}
else if (nCSG != 0) {
	for (var i=1; i<nCSG; i++) {
		curGrp = cGroupNames[i];
		if (oldChar == curGrp) {
			cSel = i;
			break;
		}
	}
}

// der Array mit den deutschen Namen der Ebenenfarben
var layerColors = new Array("Hellblau", "Rot", "Grn", "Blau", "Gelb", "Magenta", "Cyan", 
"Grau", "Schwarz", "Orange", "Dunkelgrn", "Trkis", "Hellbraun", "Braun", "Violett", "Gold", 
"Dunkelblau", "Rosa", "Lavendel", "Rotbraun", "Olivgrn", "Aprikot", "Weinrot", "Grasgrn", 
"Ocker", "Lila", "Hellgrau", "Anthrazit", "Rasterblau", "Rasterorange", "Feuerrot", "Helloliv", 
"Lippenstift", "Helltrkis", "Schwefel", "Rastergrn", "Wei");

// der Array mit den entsprechenden UIColors-Namen
var uiColors = new Array(UIColors.LIGHT_BLUE, UIColors.RED, UIColors.GREEN, UIColors.BLUE, 
UIColors.YELLOW, UIColors.MAGENTA, UIColors.CYAN, UIColors.GRAY, UIColors.BLACK, UIColors.ORANGE, 
UIColors.DARK_GREEN, UIColors.TEAL, UIColors.TAN, UIColors.BROWN, UIColors.VIOLET, UIColors.GOLD, 
UIColors.DARK_BLUE, UIColors.PINK, UIColors.LAVENDER, UIColors.BRICK_RED, UIColors.OLIVE_GREEN, 
UIColors.PEACH, UIColors.BURGUNDY, UIColors.GRASS_GREEN, UIColors.OCHRE, UIColors.PURPLE, UIColors.LIGHT_GRAY, 
UIColors.CHARCOAL, UIColors.GRID_BLUE, UIColors.GRID_ORANGE, UIColors.FIESTA, UIColors.LIGHT_OLIVE, 
UIColors.LIPSTICK, UIColors.CUTE_TEAL, UIColors.SULPHUR, UIColors.GRID_GREEN, UIColors.WHITE);

// Dialoge, welche eventuell im Speicher geblieben sind, lschen
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// einen Dialog vorbereiten
var aDialog = app.dialogs.add({name:"Gruppen, Sprache und Ebene whlen", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		if (noParaStyles == false) {
			with (dialogRows.add()) {
				if (!pRoot) {
					staticTexts.add({staticLabel:"Absatzformatgruppe kopieren:"});
					staticTexts.add({staticLabel:" "});
				}
				else {
					staticTexts.add({staticLabel:"Absatzformate"});
					staticTexts.add({staticLabel:" "});
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var paraGroup = dropdowns.add({stringList:pGroupNames, selectedIndex:pSel, minWidth:220});
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:40});
						staticTexts.add({staticLabel:"Name der neuen Gruppe:"});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:40});
						var paraName = textEditboxes.add({editContents:newParaGroupName, minWidth:224});
						staticTexts.add({staticLabel:" "});
					}
					if (pRoot) {
						var pButtons = radiobuttonGroups.add();
						with (pButtons) {
							radiobuttonControls.add({staticLabel:"Formate in die neue Gruppe *kopieren*", checkedState:pCop});
							radiobuttonControls.add({staticLabel:"Formate in die neue Gruppe *verschieben*", checkedState:pMov});
						}
					}
				}
			}
		}
		if (noCharStyles == false) {
			with (dialogRows.add()) {
				if (!cRoot) {
					staticTexts.add({staticLabel:"Zeichenformatgruppe kopieren:"});
					staticTexts.add({staticLabel:" "});
				}
				else {
					staticTexts.add({staticLabel:"Zeichenformate"});
					staticTexts.add({staticLabel:" "});
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var charGroup = dropdowns.add({stringList:cGroupNames, selectedIndex:cSel, minWidth:220});
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:40});
						staticTexts.add({staticLabel:"Name der neuen Gruppe:"});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:40});
						var charName = textEditboxes.add({editContents:newCharGroupName, minWidth:224});
						staticTexts.add({staticLabel:" "});
					}
					if (cRoot) {
						var cButtons = radiobuttonGroups.add();
						with (cButtons) {
							radiobuttonControls.add({staticLabel:"Formate in die neue Gruppe *kopieren*", checkedState:cCop});
							radiobuttonControls.add({staticLabel:"Formate in die neue Gruppe *verschieben*", checkedState:cMov});
						}
					}
				}
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Neue Sprache:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var langName = dropdowns.add({stringList:locLangList, selectedIndex:curLang, minWidth:50});
				var fButtons = radiobuttonGroups.add();
				with (fButtons) {
					radiobuttonControls.add({staticLabel:"Definition \"[Keine Sprache]\" beibehalten", checkedState:nFrc});
					radiobuttonControls.add({staticLabel:"Definition \"[Keine Sprache]\" berschreiben", checkedState:dFrc});
				}
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Zu kopierende Muster-Ebene:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var layerName = dropdowns.add({stringList:allLayers, selectedIndex:curLayer, minWidth:220});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:" ", minWidth:40});
					staticTexts.add({staticLabel:"Name und Farbe der neuen Zielebene:"});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:" ", minWidth:40});
					var layerBox = textEditboxes.add({editContents:newLayerName, minWidth:224});
					staticTexts.add({staticLabel:" "});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:" ", minWidth:40});
					var layerColor = dropdowns.add({stringList:layerColors, selectedIndex:newLayerColorID, minWidth:240});
					
				}
			}
		}
	}
}
// den Dialog zeigen
if (aDialog.show() == true) {
	// die Wahl des Anwenders bernehmen
	var newParaGroupName = "";
	if (noParaStyles == false) {
		var paraID = paraGroup.selectedIndex;
		newParaGroupName = paraName.editContents;
		if (pRoot) {
			var pLabel = pButtons.selectedButton;
			var pBtn = pLabel;
			if (pBtn == 0) {
				pCop = true;
			}
			else if (pBtn == 1) {
				pCop = false;
			}
		}
	}
	var newCharGroupName = "";
	if (noCharStyles == false) {
		var charID = charGroup.selectedIndex;
		newCharGroupName = charName.editContents;
		if (cRoot) {
			var cLabel = cButtons.selectedButton;
			var cBtn = cLabel;
			if (cBtn == 0) {
				cCop = true;
			}
			else if (cBtn == 1) {
				cCop = false;
			}
		}
	}
	var dialogIndex = langName.selectedIndex;
	var nLangs = lngNameList.length;
	for (var i=0; i<nLangs; i++) {
		if (lngNameList[i] == locLangList[dialogIndex]) {
			var newLang = i;
			break;
		}
	}
	var fLabel = fButtons.selectedButton;
	var fBtn = fLabel;
	if (fBtn == 0) {
		nFrc = true;
	}
	else if (fBtn == 1) {
		nFrc = false;
	}
	var sourceLayer = layerName.selectedIndex;
	var newLayerName = layerBox.editContents;
	var selCol = layerColor.selectedIndex;
	// den Dialog aus dem Speicher entfernen
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// die Wahl des Anwenders testen
var paraOK = false;
var oldPara = "";
if (noParaStyles == false) {
	var paraNames = curDoc.paragraphStyles.everyItem().name;
	var allPNames = paraNames.concat(pGroupNames);
	if (paraID != 0) {
		if (newParaGroupName != "" && newParaGroupName != " ") {
			for (var p=1; p<allPNames.length; p++) {
				if (allPNames[p] == newParaGroupName) {
					alert (newParaGroupName + "\nDiesen Absatzformat- oder -Gruppen-Namen\ngibt es schon. Bitte nochmals.", "Stop");
					exit();
				}
			}
			paraOK = true;
			oldPara = pGroupNames[paraID];
		}
		else {
			alert ("Bitte einen Namen fr die Absatzformatgruppe eingeben.", "Stop");
			exit();
		}
	}
}
var charOK = false;
var oldChar = "";
if (noCharStyles == false) {
	var charNames = curDoc.characterStyles.everyItem().name;
	var allCNames = charNames.concat(cGroupNames);
	if (charID != 0) {
		if (newCharGroupName != "" && newCharGroupName != " ") {
			for (var c=0; c<allCNames.length; c++) {
				if (allCNames[c] == newCharGroupName) {
					alert (newCharGroupName + "\nDiesen Zeichenformat- oder -Gruppen-Namen\ngibt es schon. Bitte nochmals.", "Stop");
					exit();
				}
			}
			charOK = true;
			oldChar = cGroupNames[charID];
		}
		else {
			alert ("Bitte einen Namen fr die Zeichenformatgruppe eingeben.", "Stop");
			exit();
		}
	}
	if (newLayerName != "" && newLayerName != " ") {
		for (var n=0; n<allLayers.length; n++) {
			if (allLayers[n] == newLayerName) {
				alert (newLayerName + "\nDiesen Ebenen-Namen gibt es schon.\nBitte nochmals.", "Stop");
				exit();
			}
		}
	}
	else {
		alert ("Bitte einen Namen fr die Zeichenformatgruppe eingeben.", "Stop");
		exit();
	}
}

// in die Datei schreiben: Quell-Absatzformat-Gruppe, neue Gruppe, kopieren, Quell-Zeichenformat-Gruppe, neue Gruppe, kopieren, Sprache, "[Keine Sprache]" belassen
if (paraOK || charOK) {
	var defArr = new Array(oldPara, newParaGroupName, pCop, oldChar, newCharGroupName, cCop, dialogIndex, nFrc, sourceLayer, newLayerName, selCol);
	var langDef = defArr.join("\n");
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/LangCopyGroup_306.txt");
	}
	else {
		var f = new File("~/Library/Preferences/LangCopyGroup_306.txt");
	}
	fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(langDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// die gewhlte Ebene kopieren und benennen
var targetLayer = curDoc.layers[sourceLayer].duplicate();
targetLayer.name = newLayerName;
targetLayer.layerColor = uiColors[selCol];

// die entsprechende(n) Gruppe(n) kopieren und umbenennen
// zuerst die Absatzformatgruppe
if (paraOK) {
	try {
		if (paraGroups[paraID-1] == "[Root]") {
			var newParaGroup = curDoc.paragraphStyleGroups.add();
			newParaGroup.name = newParaGroupName;
			var curPara, newPara, oldName, nChars;
			for (var p=nAllPara-1; p>-1; p--) {
				curPara = allParaStyles[p];
				if (curPara.name[0] != "[") {
					try {
						if (pCop) {
							nChars = curPara.name.length;
							newPara = curPara.duplicate();
							oldName = newPara.name.slice(0, nChars);
							newPara.move(LocationOptions.AT_BEGINNING, newParaGroup);
							newPara.name = oldName;
						}
						else {
							curPara.move(LocationOptions.AT_BEGINNING, newParaGroup);
						}
					}
					catch(e) {
					}
				}
			}
		}
		else {
			var newParaGroup = curDoc.paragraphStyleGroups[paraID-1].duplicate();
			newParaGroup.name = newParaGroupName;
		}
	}
	catch (e) {
	}
}
// dasselbe mit einer gewhlten Zeichenformatgruppe
if (charOK) {
	try {
		if (charGroups[charID-1] == "[Root]") {
			var newCharGroup = curDoc.characterStyleGroups.add();
			newCharGroup.name = newCharGroupName;
			var curChar, newChar, oldName, nChars;
			for (var p=nAllChar-1; p>-1; p--) {
				curChar = allCharStyles[p];
				if (curChar.name[0] != "[") {
					try {
						if (cCop) {
							nChars = curChar.name.length;
							newChar = curChar.duplicate();
							oldName = newChar.name.slice(0, nChars);
							newChar.move(LocationOptions.AT_BEGINNING, newCharGroup);
							newChar.name = oldName;
						}
						else {
							curChar.move(LocationOptions.AT_BEGINNING, newCharGroup);
						}
					}
					catch(e) {
					}
				}
			}
		}
		else {
			var newCharGroup = curDoc.characterStyleGroups[charID-1].duplicate();
			newCharGroup.name = newCharGroupName;
		}
	}
	catch (e) {
	}
}

// die Sprache der Absatzformate ndern
if (paraOK) {
	var curGroup = curDoc.paragraphStyleGroups.item(newParaGroupName);
	var curParaStyles = curGroup.allParagraphStyles;
	var nParaStyles = curParaStyles.length;
	var curStyle;
	for (var k=0; k<nParaStyles; k++) {
		try {
			curStyle = curParaStyles[k];
			if (curStyle.appliedLanguage.name[0] == "[") {
				if (!nFrc) {
					curStyle.appliedLanguage = allLang[newLang];
				}
			}
			else {
				curStyle.appliedLanguage = allLang[newLang];
			}
		}
		catch (e) {
		}
	}
}

// und auch die Sprache der Zeichenformate ndern
if (charOK) {
	var curGroup = curDoc.characterStyleGroups.item(newCharGroupName);
	var curCharStyles = curGroup.allCharacterStyles;
	var nCharStyles = curCharStyles.length;
	var curStyle;
	for (var k=0; k<nCharStyles; k++) {
		try {
			curStyle = curCharStyles[k];
			if (curStyle.appliedLanguage.name[0] == "[") {
				if (!nFrc) {
					curStyle.appliedLanguage = allLang[newLang];
				}
			}
			else {
				curStyle.appliedLanguage = allLang[newLang];
			}
		}
		catch (e) {
		}
	}
}

// eine Schleife durch Abstze und Textketten und dabei die 
// Absatz- und Zeichenformate durch jene der kopierten Gruppe ersetzen
var allCells;
var allCParas;
var allParas;
var allTables;
var allTsr;
var curCharName;
var curFrame;
var curParaName;
var curStory;
var curStyle;
var nCells;
var nCParas;
var nTables;
var nTsr;
var probPCtr = 0;
var probCCtr = 0;

var allFrames = curDoc.layers.itemByName(newLayerName).allPageItems;
var nFrames = allFrames.length;

for (var f=0; f<nFrames; f++) {
	curFrame = allFrames[f];
	if (curFrame.constructor.name == "TextFrame") {
		if (curFrame.previousTextFrame == null) {
			changeStyle(curFrame);
		}
	}
}

var allMasters = curDoc.masterSpreads;
var nMasters = allMasters.length;

for (var m=0; m<nMasters; m++) {
	allFrames = allMasters[m].allPageItems;
	nFrames = allFrames.length;
	for (var f=0; f<nFrames; f++) {
		curFrame = allFrames[f];
		if (curFrame.itemLayer == curDoc.layers.itemByName(newLayerName)) {
			if (curFrame.constructor.name == "TextFrame") {
				if (curFrame.previousTextFrame == null) {
					changeStyle(curFrame);
				}
			}
		}
	}
}

function changeStyle(curFrame) {
	curStory = curFrame.parentStory;
	if (paraOK) {
		allParas = curStory.paragraphs;
		nParas = allParas.length;
		paraStyles = allParas.everyItem().appliedParagraphStyle;
		for (var p=0; p<nParas; p++) {
			curParaName = paraStyles[p].name;
			if (curParaName[0] == "[") {
				if (allParas[p].appliedLanguage.name[0] == "[") {
					if (!nFrc) {
						allParas[p].appliedLanguage = allLang[newLang];
					}
				}
				else {
					allParas[p].appliedLanguage = allLang[newLang];
				}
			}
			else {
				try {
					curStyle = curDoc.paragraphStyleGroups.item(newParaGroupName).paragraphStyles.item(curParaName);
					allParas[p].appliedParagraphStyle = curStyle;
				}
				catch (e) {
					probPCtr++;
				}
			}
		}
		allTables = curStory.tables;
		nTables = allTables.length;
		for (var t=0; t<nTables; t++) {
			allCells = allTables[t].cells;
			nCells = allCells.length;
			for (var c=0; c<nCells; c++) {
				allCParas = allCells[c].paragraphs;
				nCParas = allCParas.length;
				cParaStyles = allCParas.everyItem().appliedParagraphStyle;
				for (var cp=0; cp<nCParas; cp++) {
					curParaName = cParaStyles[cp].name;
					if (curParaName[0] == "[") {
						allCParas[cp].appliedLanguage = allLang[newLang];
					}
					else {
						try {
							curStyle = curDoc.paragraphStyleGroups.item(newParaGroupName).paragraphStyles.item(curParaName);
							allCParas[cp].appliedParagraphStyle = curStyle;
						}
						catch (e) {
							probPCtr++;
						}
					}
				}
				if (charOK) {
					allCTsr = allCells[c].textStyleRanges;
					nCTsr = allCTsr.length;
					charStyles = allCTsr.everyItem().appliedCharacterStyle;
					for (var ct=nCTsr-1; ct>-1; ct--) {
						curCharName = charStyles[ct].name;
						if (curCharName[0] != "[") {
							try {
								curStyle = curDoc.characterStyleGroups.item(newCharGroupName).characterStyles.item(curCharName);
								allCTsr[ct].appliedCharacterStyle = curStyle;
							}
							catch (e) {
								probCCtr++;
							}
						}
					}
				}
			}
		}
		allFootNotes = curStory.footnotes;
		nNotes = allFootNotes.length;
		for (var n=0; n<nNotes; n++) {
			allNParas = allFootNotes[n].paragraphs;
			nNParas = allNParas.length;
			fParaStyles = allNParas.everyItem().appliedParagraphStyle;
			for (var np=0; np<nNParas; np++) {
				curParaName = fParaStyles[np].name;
				if (curParaName[0] == "[") {
					allNParas[np].appliedLanguage = allLang[newLang];
				}
				else {
					try {
						curStyle = curDoc.paragraphStyleGroups.item(newParaGroupName).paragraphStyles.item(curParaName);
						allNParas[np].appliedParagraphStyle = curStyle;
					}
					catch (e) {
						probPCtr++;
					}
				}
			}
			if (charOK) {
				allNTsr = allFootNotes[n].textStyleRanges;
				nNTsr = allNTsr.length;
				charStyles = allNTsr.everyItem().appliedCharacterStyle;
				for (var nt=nNTsr-1; nt>-1; nt--) {
					curCharName = charStyles[nt].name;
					if (curCharName[0] != "[") {
						try {
							curStyle = curDoc.characterStyleGroups.item(newCharGroupName).characterStyles.item(curCharName);
							allNTsr[nt].appliedCharacterStyle = curStyle;
						}
						catch (e) {
							probCCtr++;
						}
					}
				}
			}
		}
	}
	if (charOK) {
		allTsr = curStory.textStyleRanges;
		nTsr = allTsr.length;
		charStyles = allTsr.everyItem().appliedCharacterStyle;
		for (var t=nTsr-1; t>-1; t--) {
			curCharName = charStyles[t].name;
			if (curCharName[0] != "[") {
				try {
					curStyle = curDoc.characterStyleGroups.item(newCharGroupName).characterStyles.item(curCharName);
					allTsr[t].appliedCharacterStyle = curStyle;
				}
				catch (e) {
					probCCtr++;
				}
			}
		}
	}
	if (!paraOK && charOK) {
		allTables = curStory.tables;
		nTables = allTables.length;
		for (var t=0; t<nTables; t++) {
			allCells = allTables[t].cells;
			nCells = allCells.length;
			for (var c=0; c<nCells; c++) {
				allCTsr = allCells[c].textStyleRanges;
				nCTsr = allCTsr.length;
				charStyles = allCTsr.everyItem().appliedCharacterStyle;
				for (var ct=nCTsr-1; ct>-1; ct--) {
					curCharName = charStyles[ct].name;
					if (curCharName[0] != "[") {
						try {
							curStyle = curDoc.characterStyleGroups.item(newCharGroupName).characterStyles.item(curCharName);
							allCTsr[ct].appliedCharacterStyle = curStyle;
						}
						catch (e) {
							probCCtr++;
						}
					}
				}
			}
		}
		allFootNotes = curStory.footnotes;
		nNotes = allFootNotes.length;
		for (var n=0; n<nNotes; n++) {
			allNTsr = allFootNotes[n].textStyleRanges;
			nNTsr = allNTsr.length;
			charStyles = allNTsr.everyItem().appliedCharacterStyle;
			for (var nt=nNTsr-1; nt>-1; nt--) {
				curCharName = charStyles[nt].name;
				if (curCharName[0] != "[") {
					try {
						curStyle = curDoc.characterStyleGroups.item(newCharGroupName).characterStyles.item(curCharName);
						allNTsr[nt].appliedCharacterStyle = curStyle;
					}
					catch (e) {
						probCCtr++;
					}
				}
			}
		}
	}
}

// das Ende der Aktion verknden
if (probPCtr == 0 && probCCtr == 0) {
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
	dlog.show();
	// eine kleine Pause
	$.sleep(999);
	// das Fenster schliessen
	dlog.close();
}
else if (probPCtr > 0 && probCCtr > 0) {
	alert ("Im Text nicht ausgewechselte Formate\n\nAbsatzformate: " + probPCtr + "\nZeichenformate: " + probCCtr);
}
else if (probPCtr > 0 && probCCtr == 0) {
	alert ("Im Text nicht ausgewechselte Absatzformate: " + probPCtr);
}
else if (probPCtr == 0 && probCCtr > 0) {
	alert ("Im Text nicht ausgewechselte Zeichenformate: " + probCCtr);
}